/*  light.c
 *   Copyright (C) 2001 Paul Moorcroft, G.C. Hurtt and S.W. Pacala
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "ed.h"

/**************************************************************************/
/***    calculate light levels                                          ***/
/**************************************************************************/
void light_levels(struct patch **patchptr, UserData data){
  struct site *cs;
  struct patch *cp;
  struct cohort *cc;

  cp= *patchptr;
  cs= cp->siteptr;              
      /* top cohort */  
      cc = cp->tallest;
      if(cc !=NULL){ /*make sure not empty patch*/
          cc->lai =  cc->n*(1.0/cp->area)*(cc->bl*data->specific_leaf_area[cc->pft]);
	  cc->lite = cs->sdata->L_top;
          cc->lite *= exp(-COHORT_SHADING*(data->L_extinct)*(cc->lai));
	  cc = cc->shorter;
      }	/* end if */
      /* lower cohorts */
      while(cc != NULL){
         cc->lai =  cc->n*(1.0/cp->area)*(cc->bl*data->specific_leaf_area[cc->pft]);
	 cc->lite = (cc->taller)->lite*exp(-COHORT_SHADING*(data->L_extinct)*(cc->taller->lai)); 
	 /* within cohort shading*/
	 cc->lite *= exp(-COHORT_SHADING*(data->L_extinct)*(cc->lai));
	 cc=cc->shorter;
       } /* end cohort loop */

#if DEBUG_LIGHT  
  printf("*** light levels \n"); 
  print_cohort_linked_list(&cp,data);
#endif
  return;
}
/************************************************************************/










