/*  reproduction.c
 *   Copyright (C) 2001 Paul Moorcroft, G.C. Hurtt and S.W. Pacala
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "ed.h"
/***************************************************************************/
/***   reproduction                                                  *******/
/***************************************************************************/
void reproduction(unsigned int t, struct site **siteptr, UserData data){
  struct site *cs;
  struct patch *target,*source;
  struct cohort *cc;
  int pft;
  cs=*siteptr;
#if DEBUG_REPRO
  printf("repro: entered \n");
#endif
  /*for each focal patch*/
  target = cs->oldest_patch;

  while(target != NULL){
    /*goto every other patch*/
    source = cs->oldest_patch;
    while(source !=NULL){
#if DEBUG_REPRO
      printf("repro: source %p target %p \n",source,target);
#endif
      /*add in repro from all cohorts */
      /* weight by the fraction of total area that is the focal patch*/
      cc = source->tallest;
      while (cc != NULL){  
        /* global dispersal */
        pft = cc->pft;	
	target->repro[pft]+= data->m[pft]*cc->n*(1.0 - data->sd_mort)*cc->p[0]*(1.0/AREA)*data->deltat;
	if(source==target) /* if source = target add in local dispersal */
	  target->repro[pft]+= cc->n*(1.0-data->m[pft])*(1.0 - data->sd_mort)*cc->p[0]*(1.0/target->area)*data->deltat;
	cc = cc->shorter;  
      }
      source = source->younger;
    }
    target = target->younger;
  }  /* end loop over targets */

#if DEBUG_REPRO
  printf("repro: exit \n"); 
#endif

  return;
}
/**************************************************************************/





